#!/usr/bin/perl
use strict;
use warnings;

use FindBin;
use lib $FindBin::RealBin;

use DevTools qw/taupu get_version wc_l/;


#------------------------------------------------------------------------------
# Dateien ermitteln:
#------------------------------------------------------------------------------
my @files = <$FindBin::RealBin/../Graph/GED/*.*>;
push @files, "$FindBin::RealBin/../ged.pl";
#print "@files\n";

#------------------------------------------------------------------------------
# Gren ermitteln:
#------------------------------------------------------------------------------
my @sizes;
push @sizes, -s $_ for @files;
my $sizesum = 0;
$sizesum += $_ for @sizes;
$_ = taupu $_ for (@sizes, $sizesum);
#print "Groessen: @sizes\nSumme   : $sizesum\n";

#------------------------------------------------------------------------------
# Zeilen ermitteln:
#------------------------------------------------------------------------------
my @lines;
for my $f (@files) { push @lines, wc_l($f) }
my $linessum = 0;
$linessum += $_ for @lines;
$_ = taupu $_ for (@lines, $linessum);
#print "Zeilen: @lines\nSumme : $linessum\n";

#------------------------------------------------------------------------------
# Arraygren gleich?!
#------------------------------------------------------------------------------
my $n = @files;
die "Arraygroessenfehler!" unless $n == @files and
                                  $n == @sizes and
                                  $n == @lines   ;

#------------------------------------------------------------------------------
# Version ermitteln:
#------------------------------------------------------------------------------
my ($version, $datum) = get_version("$FindBin::RealBin/../Graph/GED/Core.pm");
print "Version: $version vom $datum\n";


#------------------------------------------------------------------------------
# / in :: umsetzen:
#------------------------------------------------------------------------------
s~^$FindBin::RealBin/../~~ for @files;
s~/~::~g for @files;

#------------------------------------------------------------------------------
# Maximallaenge ermitteln:
#------------------------------------------------------------------------------
my $len = 0;
for my $f (@files) { $len = length($f) unless $len >= length($f) }

#------------------------------------------------------------------------------
# Ergebnisausgabe fr ged.pl:
#------------------------------------------------------------------------------
print "\n\nVersion $version vom $datum\n", '~' x (8+length($version)), "\n";
for (0..$n-1) {
    printf(">%8s Byte -%7s Zeilen - %*s\n",
           $sizes[$_], $lines[$_], $len, $files[$_]);
}
print  "> -------        ------\n";
printf(">%8s Byte -%7s Zeilen\n",
       $sizesum, $linessum);

#------------------------------------------------------------------------------
# Ergebnisausgabe fr ged.html:
#------------------------------------------------------------------------------
print "\n\n            <h3>Version $version vom $datum</h3>\n";
print <<'END';
            <table class="stat" border="2">
                <tr>
                    <th>Byte</th>
                    <th>Zeilen</th>
                    <th>Datei</th>
                </tr>
END
for (0..$n-1) {
    print <<"END";
                <tr class="statline">
                    <td>$sizes[$_]</td>
                    <td>$lines[$_]</td>
                    <td>$files[$_]</td>
                </tr>
END
}
print <<"END";
                <tr class="statsum">
                    <td>$sizesum</td>
                    <td>$linessum</td>
                    <td></td>
                </tr>
            </table>
END




__END__
> 167.508 Byte - 3.905 Zeilen -     ged_2004_02_10_c.pl
>   5.884 Byte -   177 Zeilen -     FHist_2004_02_10.pm
>   9.367 Byte -   291 Zeilen -      Geom_2004_02_10.pm
>  25.045 Byte -   651 Zeilen -   Graph_2004_02_10_c.pm
>  40.159 Byte - 1.000 Zeilen - Graph2d_2004_02_10_c.pm
>   4.019 Byte -   111 Zeilen -    Ecke_2004_02_10_c.pm
>   5.149 Byte -   139 Zeilen -   Kante_2004_02_10_c.pm
>   8.480 Byte -   200 Zeilen -     Basis_2004_02_10.pm
>   4.656 Byte -   123 Zeilen -  Historie_2004_02_10.pm
> -------        -----
> 270.267 Byte - 6.653 Zeilen



            <table class="stat" border="2">
                <tr>
                    <th>Byte</th>
                    <th>Zeilen</th>
                    <th>Datei</th>
                </tr>
                <tr class="statline">
                    <td>167.508</td>
                    <td>3.905</td>
                    <td>ged.pl</td>
                </tr>
                <tr class="statline">
                    <td>5.884</td>
                    <td>177</td>
                    <td>Graphen::GED::FHist.pm</td>
                </tr>
                <tr class="statline">
                    <td>9.367</td>
                    <td>291</td>
                    <td>Graphen::GED::Geom.pm</td>
                </tr>
                <tr class="statline">
                    <td>25.045</td>
                    <td>651</td>
                    <td>Graphen::GED::Graph.pm</td>
                </tr>
                <tr class="statline">
                    <td>40.159</td>
                    <td>1.000</td>
                    <td>Graphen::GED::Graph2d.pm</td>
                </tr>
                <tr class="statline">
                    <td>4.019</td>
                    <td>111</td>
                    <td>Graphen::GED::Ecke.pm</td>
                </tr>
                <tr class="statline">
                    <td>5.149</td>
                    <td>139</td>
                    <td>Graphen::GED::Kante.pm</td>
                </tr>
                <tr class="statline">
                    <td>8.480</td>
                    <td>200</td>
                    <td>Graphen::GED::Basis.pm</td>
                </tr>
                <tr class="statline">
                    <td>4.656</td>
                    <td>123</td>
                    <td>Graphen::GED::Historie.pm</td>
                </tr>
                <tr class="statsum">
                    <td>270.267</td>
                    <td>6.653</td>
                    <td></td>
                </tr>
            </table>
